# Health Checks

All ESS services support and are configured with [Kubernetes liveness, readiness and startup probes](https://kubernetes.io/docs/tasks/configure-pod-container/configure-liveness-readiness-startup-probes/) . These allow Kubernetes to check the health of each service, and automatically manage the lifecycle of ESS services, providing reliability and resiliency.

### Startup probes

```yaml
startupProbe:
  httpGet:
    path: /q/health/started
    port: 8443
    scheme: HTTPS
  failureThreshold: 120
  periodSeconds: 1
```

Startup probes allow Kubernetes to detect when a newly created container has completed starting up. Other probes will not be performed on it until it has finished starting up.

### Readiness probes

```yaml
livenessProbe:
  httpGet:
    path: /q/health/live
    port: 8443
    scheme: HTTPS
  timeoutSeconds: 1
  failureThreshold: 30
  periodSeconds: 10
```

Readiness probes indicate to Kubernetes that the service is ready and able to receive requests. A Pod with containers that are failing readiness probes will be removed from its associated Services, and thus will not receive requests until it returns to a ready state.

### Liveness probes

```yaml
readinessProbe:
  httpGet:
    path: /q/health/ready
    port: 8443
    scheme: HTTPS
  timeoutSeconds: 30
  periodSeconds: 10
  successThreshold: 1
  failureThreshold: 3
```

Liveness probes indicate to Kubernetes whether the container needs to be restarted.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.inrupt.com/ess/2.5/administration/health-checks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
